#%RAML 1.0
title: S360
baseUri: https://s360.com.br/api/
protocols: [ HTTPS ]
mediaType:  application/json
version: 4.1
documentation:
  - title: Welcome to S360 API documentation! | Seja bem vindo a documentação da API 360!
    content: |
      Here you will find information on how to use system integration.
      The access control of this api requires a valid user in the system. To access you
      You will need to contact us at als.sac@alsglobal.com and request a user and
       password. Be sure to also access the sandbox environment or homologation.

      Aqui você irá encontrar informações de como utilizar a integração com o sistema.
      O controle de acesso desta api necessita de um usuário válido no sistema. Para acessar você
      precisará de entrar em contato no e-mail als.sac@alsglobal.com e solicitar um usuário e
       senha. Não deixe de acessar também o ambiente de sandbox ou homologação.
       https://homol.s360web.com/api/

securitySchemes:
  basic:
      type: Basic Authentication
      describedBy:
        headers:
          Authorization:
            description: |
              Used to send the access token generated in the Login endpoint. Example: "Authorization: Bearer eyJhbGciOiJIUzI1NiJ9"
              type: string.

              ###IMPORTANT! The token will expire at least once a day.

              Utilizado para enviar o access token gerado no Login endpoint. Exemplo: "Authorization: Bearer eyJhbGciOiJIUzI1NiJ9"
              type: string.

              ###IMPORTANTE! O token irá expirar ao menos uma vez ao dia.

types:
  ResultadoAnalise: !include type/ResultadoAnalise.raml
  CampoExtraAmostra: !include type/CampoExtraAmostra.raml
  ComentarioAmostra: !include type/ComentarioAmostra.raml
  ResultadoAmostraListagem: !include type/ResultadoAmostraListagem.raml
  ListaResultadosAmostras: !include type/ListaResultadosAmostras.raml
  ResultadoAmostraCompleto: !include type/ResultadoAmostraCompleto.raml
  Usuario: !include schemas/Usuario.json
  ListaAmostras: !include schemas/ListaAmostras.json
  Amostra: !include type/Amostra.raml
  FiltroAmostras: !include schemas/FiltroAmostras.json
  FiltroResultados: !include type/FiltroResultados.raml
  ListaTipoCompartimentos: !include schemas/ListaTipoCompartimentos.json
  ListaViscosidadesOleo: !include schemas/ListaViscosidadesOleo.json
  ListaFabricantesOleo: !include schemas/ListaFabricantesOleo.json
  Arquivo: !include schemas/Arquivo.json
  Notificacoes: !include schemas/Notificacoes.json
  RegistroColeta: !include type/RegistroColeta.raml
  ListaEquipamentos: !include schemas/ListaEquipamentos.json
  FiltroEquipamentos: !include type/FiltroEquipamentos.raml
  Equipamento: !include schemas/Equipamento.json
  ListaFamiliasEquipamentos: !include schemas/ListaFamiliasEquipamentos.json
  ListaFabricantesEquipamentos: !include schemas/ListaFabricantesEquipamentos.json
  NovoEquipamento: !include type/NovoEquipamento.raml
  EditarEquipamento: !include schemas/EditarEquipamento.json
  NovoCompartimento: !include schemas/NovoCompartimento.json
  EditarCompartimento: !include schemas/EditarCompartimento.json
  ListaClientes: !include schemas/ListaClientes.json
  FiltroClientes: !include schemas/FiltroClientes.json
  ListaObras: !include schemas/ListaObras.json
  FiltroObras: !include schemas/FiltroObras.json
  ListaProgramas: !include schemas/ListaProgramas.json
  FiltroProgramas: !include schemas/FiltroProgramas.json
  ResultadoCadastro: !include schemas/ResultadoCadastro.json
  ResultadoExcluir: !include schemas/ResultadoExcluir.json
  Excluir: !include schemas/Excluir.json
  ExcluirColeta: !include schemas/ExcluirColeta.json
  ValidadeNoPrograma: !include type/ValidadeNoPrograma.raml
  RetornoPadrao: !include type/RetornoPadrao.raml

traits:
  resultado:
      queryParameters:
        statusResultado:
          type: string
          enum: ["NORMAL","ATENCAO","ANORMAL","CRITICO"]
          displayName: Status do resultado
          description: |
            Represents the status of the sample result. _NORMAL: _ Indicated that the results are within the normal range expected for the equipment.

            Representa a situação do resultado da amostra. _NORMAL:_ Indicado que os resultados estão dentro da normalidade esperada para o equipamento.

          example: NORMAL
  slidingwindow:
           description: Query parameters related to retrieving a sliding window of timestamped entities relative to now.
           queryParameters:
             windowstart:
               description: The begining of the sliding window expressed as a time interval from now represented as an integer concatenated with units h (hours), m (minutes), s (seconds) or ms (milliseconds).
               type: string
               example: 1h, 30m, 3600s
             windowsize:
               description: The end of the sliding window expressed as a time interval from the start as a concatenated integer and unit suffix.
               type: string
               example: 10s, 1h, 25m
  paginated:
      queryParameters:
            numeroPagina:
                description: The page number of the result-set to return.
                type: integer
                minimum: 0
            maximoPorPagina:
                description: The number of rows in a page request.
                type: integer
                maximum: 100
  limited:
           queryParameters:
             limit:
               description: O número de linhas que a paginação suporta.
               type: integer
               default: 100

/login:
  displayName: Login
  description: |
    Called to log in to the application and receive a security token.

    Chamada para efetuar login na aplicação e receber um token de segurança.
  post:
    description: |
      Login
    
      Realiza o login
    body:
      application/json:
        type: Usuario
        example: !include examples/Usuario01.json
    responses:
      200:
        body:
          application/json:
            example: |
              {
                "access_token":"eyJhbGciOiJIUzI1NiJ9.eyJleHAiOjE0MjI5OTU5MjIsInN1YiI6ImppbWkiLCJyb2xlcyI6WyJST0xFX0FETUlOIiwiUk9MRV9VU0VSIl0sImlhdCI6MTQyMjk5MjMyMn0.rA7A2Gwt14LaYMpxNRtrCdO24RGrfHtZXY9fIjV8x8o",
                "token_type":"Bearer",
                "username": "john.doe",
                "permissions": [
                    "ROLE_ADMIN",
                    "ROLE_USER"
                ]
              }

/logout:
  displayName: Logout endpoint
  securedBy: [basic]
  description: |
    Call to log out of the application invalidating an existing token

    Chamada para efetuar o logout na aplicação invalidando um token existente
  post:
    responses:
      200:
        description: |
          Logout completed successfully.

          Logout realizado com sucesso.

/v3/resultadoAmostra/list:
  displayName: List of sample results | Lista de resultados das amostras
  securedBy: [basic]
  description: |
    Search for a listing of sample results. It does not retrieve detailed sample data.
    If you are going to develop a robot to fetch sample data, I recommend using this method
    in conjunction with the view result.
    Make an inquiry using the _statusLeitura_ filter with the information of SOMENTE_NAO_LIDO.
    So you will get a list of all samples that are have been integrated. For each one
    them, trigger the view. On the next search, these samples will no longer be reported to you.

    Busca por uma listagem de resultados de amostras. Não recupera dados detalhados das amostras.
    Se você for desenvolver um robô para buscar dados da amostra, recomendo utilizar este método
    em conjunto com o resultado view.
    Faça uma consulta utilizando o filtro de _statusLeitura_ com a informação de SOMENTE_NAO_LIDO.
    Assim você irá receber uma lista de todas as amostras que são foram integradas. Para cada uma
    delas, acione o view. Na próxima busca, estas amostras não serão mais informadas para vocês.

  post:
    description: |
      Performs the search for sample results.

      Realiza a busca de resultados de amostras.
    body:
      application/json:
        type: FiltroResultados
        example: !include examples/FiltroResultados01.json
    responses:
      200:
        body:
            application/json:
              type: ListaResultadosAmostras

/v3/resultadoAmostra/view:
  displayName: View sample result| Ver resultado da amostra
  description: |
    Returns the result data of a sample in the JSON format. When executed, it will mark the result as read by the user.

    Retorna os dados do resultado de uma amostra no formato JSON. Ao ser executado, irá marcar o resultado como lido pelo usuário.
  securedBy: [basic]
  get:
    description: |
      Returns the result of a sample.
      
      Retorna resultado de uma amostra.
    queryParameters:
      numeroAmostra:
        type: string
        required: true
    responses:
      200:
       body:
          application/json:
            type: ResultadoAmostraCompleto

/v1/resultadoAmostra/viewPdf:
  displayName: View sample result in PDF| Ver resultado da amostra em PDF
  description: |
    Returns the sample result in PDF format. When executed, it will mark the result as read by the user.

    Retorna o resultado da amostra no formato PDF. Ao ser executado, irá marcar o resultado como lido pelo usuário.
  securedBy: [basic]
  get:
    description: |
      Returns the pdf of a sample result.

      Retorna o pdf de um resultado de amostra.
    queryParameters:
      numeroAmostra:
        type: string
        required: true
    responses:
      200:
        body:
          application/octet-stream:

/v1/resultadoAnalise/view:
  displayName: View result of a binary analysis | Ver resultado de uma análise binária
  description: |
    Returns a file (image or pdf) related to an analysis result.

    Retorna um arquivo (imagem ou pdf) relacionado a um resultado de análise.
  securedBy: [basic]
  get:
    description: |
      Returns the binary of an analysis result.

      Retorna o binário de um resultado de análise.
    queryParameters:
      idResultadoAnalise:
        type: number
        required: true
    responses:
      200:
        body:
          application/octet-stream:

/v1/amostra/list:
  displayName: List of samples | Lista das amostras
  securedBy: [basic]
  description: |
    Search for a sample listing, regardless of whether or not it is finalized.
    It does not retrieve detailed sample data.

    Busca por uma listagem das amostras, independente de estar ou não finalizada.
    Não recupera dados detalhados das amostras.

  post:
    description: |
      Performs the sample search.

      Realiza a busca nas amostras.
    body:
      application/json:
        type: FiltroAmostras
    responses:
      200:
        body:
            application/json:
              type: ListaAmostras

/v1/amostra/view:
  displayName: View Sample | Ver amostra
  description: |
    Returns the data of a sample.

    Retorna os dados de uma amostra.
  securedBy: [basic]
  get:
    description: |
      Returns detailed sample data.

      Retorna dados detalhados da amostra.
    queryParameters:
      numeroAmostra:
        type: string
        required: true
    responses:
      200:
       body:
          application/json:
            type: Amostra
            example: !include examples/Amostra01.json

/v1/amostra/registrarColeta:
  displayName: Records sample collection | Registra coleta na amostra
  securedBy: [basic]
  description: |
    Records a collection in a sample. Can be used while the sample has not entered the laboratory.
    There are two types of collection. AVULSA, where the equipment is not necessary. EQUIPAMENTO, where equipment data is required.

    Registra uma coleta em uma amostra. Pode ser utilizado enquanto a amostra não entrou no laboratório.
    São dois tipos de coleta. AVULSA, onde o equipamento não é necessário. EQUIPAMENTO, onde os dados do equipamento são necessários.

  post:
    description: |
      Records collection in a sample.

      Registra coleta em uma amostra.
    body:
      application/json:
        type: RegistroColeta
        example: !include examples/RegistrarColeta01.json

    responses:
      200:
        body:
            application/json:
              type: ResultadoCadastro

/v1/amostra/excluirRegistroColeta:
  displayName: Excludes sample collection | Exclui a coleta na amostra
  securedBy: [basic]
  description: |
    Deletes a collection record. It can only be run while the sample has not been received by the laboratory. After receiving, you can only edit. After entering the laboratory for processing, it can not be changed or deleted.

    Exclui um registro de coleta. Somente pode ser executado enquanto a amostra não foi recebida pelo laboratório. Após recebimento, somente poderá editar. Após entrar no laboratório para ser processada, não poderá ser alterada e nem excluída.

  post:
    description: |
      Exclude collection in a sample.

      Excluir coleta em uma amostra.

    body:
      application/json:
        type: ExcluirColeta
        example: !include examples/ExcluirColeta01.json

    responses:
      200:
        body:
            application/json:
              type: ResultadoExcluir

/v1/amostra/validadeNoPrograma:
  displayName: Records the validity of the sample in the program. | Registra a validade da amostra no programa
  securedBy: [basic]
  description: |
    Records whether a sample is valid for a particular program. Used by program managers to define, at their own discretion,
     whether or not a sample is valid in the program.

    Registra se uma amostra é válida para um determinado programa. Usado pelos gestores dos programas para definir, através de seus próprios critérios, 
    se uma amostra está ou não válida no programa.

    Esta alteração pode ser realizada até o recebimento da amostra pelo laboratório.
  post:
    description: |
      Records the validity of the sample in the program.

      Registra a validade da amostra no programa
    body:
      application/json:
        type: ValidadeNoPrograma
        example: !include examples/ValidadeNoPrograma01.json

    responses:
      200:
        body:
            application/json:
              type: RetornoPadrao

/v1/amostra/listViscosidadesOleo:
  displayName: See viscosity of oil | Ver viscosidade do óleo
  securedBy: [basic]
  description: |
    Returns the list of oil viscosities that are supported.

    Retorna a lista das viscosidades do óleo que são suportado.
  get:
    description: |
      It performs the search without filter.

      Realiza a busca sem filtro.
    responses:
      200:
        body:
          application/json:
            type: ListaViscosidadesOleo

/v1/amostra/listFabricanteOleo:
  displayName: View oil manufacturers| Ver fabricantes de óleo
  securedBy: [basic]
  description: |
    Returns the list of oil manufacturers that are supported.

    Retorna a lista dos fabricantes de óleo que são suportado.
  get:
    description: |
      It performs the search without filter.

      Realiza a busca sem filtro.
    responses:
      200:
        body:
          application/json:
            type: ListaFabricantesOleo

/v1/equipamento/list:
  displayName: List of equipment | Lista de equipamento
  securedBy: [basic]
  description: |
    Returns the list of equipment registered.

    Retorna a lista dos equipamentos cadastrados.
  post:
    body:
      application/json:
        type: FiltroEquipamentos
    description: |
      Do the search.

      Realiza a busca.
    responses:
      200:
        body:
          application/json:
            type: ListaEquipamentos

/v1/equipamento/view:
  displayName: View Equipment Data | Ver dados do equipamento
  securedBy: [basic]
  description: |
    Returns the data of a registered equipment.

    Retorna os dados de um equipamento cadastrado.
  get:
    description: |
      Do the search.

      Realiza a busca.
    queryParameters:
      id:
        type: integer
        required: true  
    responses:
      200:
        body:
          application/json:
            type: Equipamento
            example: !include examples/Equipamento01.json

/v1/equipamento/listFamilia:
  displayName: Equipment family list | Lista de familia de equipamentos
  securedBy: [basic]
  description: |
    Returns the list of all equipment families.

    Retorna a lista de todas as familias de equipamentos.
  get:
    responses:
      200:
        body:
          application/json:
            type: ListaFamiliasEquipamentos
            example: !include examples/ListaFamilia01.json

/v1/equipamento/listFabricante:
  displayName: Equipment Manufacturer List | Lista de fabricante de equipamentos
  securedBy: [basic]
  description: |
    Returns the list of all equipment manufacturers.

    Retorna a lista de todas as fabricantes de equipamentos.
  get:
    responses:
      200:
        body:
          application/json:
            type: ListaFabricantesEquipamentos
            example: !include examples/ListaFabricanteEquipamento01.json

/v1/equipamento/novo:
  displayName: New equipment | Novo equipamento
  securedBy: [basic]
  description: |
    Creates a new record for an item.

    Cria um novo registro de um equipamento.
  post:
    description: |
      Create new equipment.

      Cria um novo equipamento.
    body:
      application/json:
        type: NovoEquipamento
    responses:
      200:
        body:
            application/json:
              type: ResultadoCadastro

/v1/equipamento/editar:
  displayName: Edit Equipment | Editar equipamento
  securedBy: [basic]
  description: |
    Changes the registration of an equipment.

    Altera o registro de um equipamento.
  post:
    description: |
      Edit an item.

      Edita um equipamento.
    body:
      application/json:
        type: EditarEquipamento
    responses:
      200:
        body:
            application/json:
              type: ResultadoCadastro

/v1/equipamento/excluir:
  displayName: Delete equipament | Excluir equipamento
  securedBy: [basic]
  description: |
    Deletes the log of an equipment and all its compartments / collection points.

    Apaga o registro de um equipamento e todos seus compartimentos/pontos de coleta.
  post:
    description: |
      Deleting equipment.

      Apagar um equipamento.
    body:
      application/json:
        type: Excluir
    responses:
      200:
        body:
            application/json:
              type: ResultadoExcluir
              example: !include examples/Excluir01.json

/v1/equipamento/novoCompartimento:
  displayName: New compartiment | Novo compartimento
  securedBy: [basic]
  description: |
    Creates a new compartment / collection point record.

    Cria um novo registro de compartimento/ponto de coleta.
  post:
    description: |
      Creates a new compartment.

      Cria um novo compartimento.
    body:
      application/json:
        type: NovoCompartimento
    responses:
      200:
        body:
            application/json:
              type: ResultadoCadastro

/v1/equipamento/editarCompartimento:
  displayName: Edit compartment | Editar compartimento
  securedBy: [basic]
  description: |
    Changes the registration of a compartment / collection point.

    Altera o registro de um compartimento/ponto de coleta.
  post:
    description: |
      Edit a compartment.

      Edita um compartimento.
    body:
      application/json:
        type: EditarCompartimento
        example: !include examples/EditarCompartimento01.json
    responses:
      200:
        body:
            application/json:
              type: ResultadoCadastro
              example: !include examples/ResultadoEditarCompartimento01.json

/v1/equipamento/excluirCompartimento:
  displayName: Delete compartment | Excluir compartimento
  securedBy: [basic]
  description: |
    Clears the log of a compartment / collection point.

    Apaga o registro de um compartimento/ponto de coleta.
  post:
    description: |
      Delete a compartment.

      Apagar um compartimento.
    body:
      application/json:
        type: Excluir
    responses:
      200:
        body:
            application/json:
              type: ResultadoExcluir
              example: !include examples/Excluir01.json

/v1/cliente/list:
  displayName: List of customers | Lista de clientes
  securedBy: [basic]
  description: |
    Returns the list of clients in which it has access.

    Retorna a lista dos clientes nos quais tem acesso.
  post:
    description: |
      Do the search.

      Realiza a busca.
    body: 
      application/json:
        type: FiltroClientes
    responses:
      200:
        body:
          application/json:
            type: ListaClientes
            example: !include examples/ListaCliente01.json

/v1/obra/list:
  displayName: List of works / units | Lista de obras/unidades
  securedBy: [basic]
  description: |
    Returns the list of works in which it has access.

    Retorna a lista das obras nos quais tem acesso.
  post:
    description: |
      Do the search.
      
      Realiza a busca.
    body: 
      application/json:
        type: FiltroObras
    responses:
      200:
        body:
          application/json:
            type: ListaObras
            example: !include examples/ListaObras01.json

/v1/programa/list:
  displayName: List of programs | Lista de programas
  securedBy: [basic]
  description: |
    Returns the list of programs. Only users associated with any program will receive a list.

    Retorna a lista de programas. Somente usuários associados a algum programa receberá uma lista.
  post:
    description: |
      Do the search.

      Realiza a busca
    body: 
      application/json:
        type: FiltroProgramas
    responses:
      200:
        body:
          application/json:
            type: ListaProgramas
            example: !include examples/ListaProgramas01.json

/v1/tipoCompartimento/list:
  displayName: View compartment types | Ver tipos de compartimento
  securedBy: [basic]
  description: |
    Returns the list of compartment types. Types are an important part of the system as they help define which analyzes are performed for the compartments.

    Retorna a lista dos tipos de compartimentos. Os tipos são parte importante do sistema, pois auxiliam a definir quais análises são realizadas para os compartimentos.
  get:
    description: |
      It performs the search without filter.

      Realiza a busca sem filtro.
    responses:
      200:
        body:
          application/json:
            type: ListaTipoCompartimentos
            example: !include examples/ListaTipoCompartimentos01.json

/v1/notificacao/buscarUsuariosPorDataFinalizacao:
  description: |
    Search which users have finished samples within an informed period.
    This method is only for people who are allowed access. It should be used to send notifications (e-mail, SMS, Push, etc.).

    Busca quais usuários tem amostras finalizadas dentro de um período informado.
    Este método é exclusivo para pessoas com permissão de acesso. Deverá ser utilizado para envio de notificações (e-mail, SMS, Push, etc.).
  displayName: |
    Search users for notification by result date

    Busca usuários para notificação por data de resultado
  securedBy: [basic]
  get:
    description: |
      Returns lists of users who have finished samples within the period. When there are no users to be notified, the listing will return empty.

      Retorna listas de usuários que possuem amostras finalizadas dentro do período. Quando não existir usários para serem notificados, a listagem irá retornar vazia.
    queryParameters:
      de:
        description: |
          Start date of the query.

          Data inicial da consulta.
        type: string
        required: true
        example: "2017-04-12T15:00:00Z"
      ate:
        description: |
          Query end date.
          
          Data de término da consulta.
        type: string
        required: true
        example: "2017-04-12T16:00:00Z"
    responses:
      200:
        body:
          application/json:
            type: Notificacoes
            example: !include examples/UsuariosParaNotificacao.json
